#include <bits/stdc++.h>

using namespace std;

int main()
{
    cin.tie(NULL);
    ios_base::sync_with_stdio(false);
    int n, o, a, b, ab;
    vector<pair<string, int> > v;
    cin >> n >> o >> a >> b >> ab;
    int krv[n + 5][5] = {0};
    for(int i = 0; i < n; i++)
    {
        string s;
        int k;
        cin >> s >> k;
        v.push_back(make_pair(s, k));
    }

    for(int i = 0; i < n; i++)
    {
        if(v[i].first == "O" && o > 0)
        {
            if(o > v[i].second)
            {
                o -= v[i].second;
                krv[i][0] = v[i].second;
                v[i].second = 0;
            }
            else
            {
                v[i].second -= o;
                krv[i][0] = o;
                o = 0;
            }
        }

        if(v[i].first == "A")
        {
            if(a > 0)
            {
                if(a > v[i].second)
                {
                    a -= v[i].second;
                    krv[i][1] = v[i].second;
                    v[i].second = 0;
                }
                else
                {
                    v[i].second -= a;
                    krv[i][1] = a;
                    a = 0;
                }
            }
        }

        if(v[i].first == "B")
        {
            if(b > 0)
            {
                if(b > v[i].second)
                {
                    b -= v[i].second;
                    krv[i][2] = v[i].second;
                    v[i].second = 0;
                }
                else
                {
                    v[i].second -= b;
                    krv[i][2] = b;
                    b = 0;
                }
            }
        }

        if(v[i].first == "AB" && ab > 0)
        {
            if(ab > v[i].second)
            {
                ab -= v[i].second;
                krv[i][3] = v[i].second;
                v[i].second = 0;
            }
            else
            {
                v[i].second -= ab;
                krv[i][3] = ab;
                ab = 0;
            }
        }
    }

    for(int i = 0; i < n; i++)
    {
        if(v[i].first == "A" && v[i].second > 0)
        {
            if(o > v[i].second)
            {
                o -= v[i].second;
                krv[i][0] = v[i].second;
                v[i].second = 0;
            }
            else
            {
                v[i].second -= o;
                krv[i][0] = o;
                o = 0;
            }
        }

        if(v[i].first == "B" && v[i].second > 0)
        {
            if(o > v[i].second)
            {
                o -= v[i].second;
                krv[i][0] = v[i].second;
                v[i].second = 0;
            }
            else
            {
                v[i].second -= o;
                krv[i][0] = o;
                o = 0;
            }
        }
    }

    for(int i = 0; i < n; i++)
    {
        if(v[i].first == "AB" && v[i].second > 0)
        {
            if(a > v[i].second)
            {
                a -= v[i].second;
                krv[i][1] = v[i].second;
                v[i].second = 0;
            }
            else
            {
                v[i].second -= a;
                krv[i][1] = a;
                a = 0;
            }

            if(b > v[i].second)
            {
                b -= v[i].second;
                krv[i][2] = v[i].second;
                v[i].second = 0;
            }
            else
            {
                v[i].second -= b;
                krv[i][2] = b;
                b = 0;
            }

            if(o > v[i].second)
            {
                o -= v[i].second;
                krv[i][0] = v[i].second;
                v[i].second = 0;
            }
            else
            {
                v[i].second -= o;
                krv[i][0] = o;
                o = 0;
            }
        }
    }

    bool t = true;
    for(int i = 0; i < n; i++)
    {
        if(v[i].second > 0) t = false;
    }

    if(t)
    {
        cout << "moguce" << endl;
        for(int i = 0; i < n; i++)
        {
            for(int j = 0; j < 4; j++)
            {
                cout << krv[i][j] << " ";
            }
            cout << endl;
        }
    }
    else cout << "nemoguce" << endl;
}